import PropTypes from 'prop-types';
import cx from 'classnames';
import Circle from './Circle/index.js';
import { BASE_CLASS_NAME, SIZE_TO_WIDTH_LINE_MAP } from './settings.js';
import { STATUS, SIZES } from '../settings.js';
import Indicator from './Indicator.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var ProgressBarCircle = function ProgressBarCircle(_ref) {
  var percentage = _ref.percentage,
      status = _ref.status,
      errorIcon = _ref.errorIcon,
      size = _ref.size,
      isAnimatedOnChange = _ref.isAnimatedOnChange,
      hideIndicator = _ref.hideIndicator,
      children = _ref.children;
  var circleWidth = SIZE_TO_WIDTH_LINE_MAP[size];
  return /*#__PURE__*/_jsxs("div", {
    className: cx(BASE_CLASS_NAME, BASE_CLASS_NAME + "--" + size, BASE_CLASS_NAME + "--" + status),
    children: [/*#__PURE__*/_jsx(Circle, {
      baseClassName: BASE_CLASS_NAME,
      modifier: status,
      percentage: status === STATUS.PROGRESS ? percentage : 0,
      withAnimation: isAnimatedOnChange,
      strokeWidth: circleWidth,
      size: size
    }), !hideIndicator && /*#__PURE__*/_jsx(Indicator, {
      percentage: percentage,
      size: size,
      status: status,
      errorIcon: errorIcon,
      children: children
    })]
  });
};

ProgressBarCircle.displayName = 'ProgressBarCircle';
ProgressBarCircle.defaultProps = {
  isAnimatedOnChange: false,
  status: STATUS.PROGRESS,
  hideIndicator: false,
  size: SIZES.LARGE
};
export default ProgressBarCircle;